version: v4
base: docker-registry.wikimedia.org/nodejs12-slim
lives:
  in: /srv/service
runs:
  environment: { APP_BASE_PATH: /srv/service }

variants:
  dev:
    base: docker-registry.wikimedia.org/nodejs12-devel
    apt: { packages: [git, build-essential] }
    node: { requirements: [package.json, package-lock.json] }
    entrypoint: [npm, run, dev]
  build:
    base: docker-registry.wikimedia.org/nodejs12-devel
    copies: [local]
    apt: { packages: [git, build-essential, python, pkg-config] }
    node: { requirements: [package.json] }
    runs: { environment: { LINK: g++ } }
  development:
    includes: [build]
    apt: { packages: [ca-certificates] }
    entrypoint: [node, server.js]
  test:
    includes: [build]
    apt: { packages: [ca-certificates] }
    entrypoint: [npm, test]
  prep:
    includes: [build]
    node: { env: production }
  production:
    copies: [prep]
    node: { env: production }
    apt: { packages: [ca-certificates, wmf-certificates] }
    entrypoint: [node, server.js]
